//Erick Leon, 2015
//Based off the code by Pradeep Padala http://www.linuxjournal.com/article/6100?page=0,2 
#include <sys/ptrace.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <sys/user.h>
#include <sys/reg.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdint.h>
#include <sys/syscall.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>

int main(int argc, char** argv){//main function
clock_t t;//benchmarking
t=clock();//benchmarking
int calll=0;//updates destiny after call
int i;//for
int counter=0;
FILE *ptr_file; //file storing hex values
uint64_t instr,check,dest,op,op2;//store the hex values of instructions and eip/rip and opcodes
uint64_t bfr[999999];
pid_t child; //child process
const int long_size = sizeof(long);
  if(argc < 2){
  fprintf(stderr, "Invalid\n");
  return -1;
  }//if argc
child = fork();//fork the child from the parent
  if(child == 0){ //no child process exist  
  ptrace(PTRACE_TRACEME, 0, NULL, NULL); //trace the process
  execl(argv[1], argv[1] , (char*)0); //run the program
  }else{
  int status; //variables to control status
    union u{
    long val;
    char chars[long_size];
    }data;
  struct user_regs_struct regs; //regs for EIP or RIP
  int start = 0;
    while(1){
    wait(&status);//stores the status of wait
      if(WIFEXITED(status))//if done
      break;
    ptrace(PTRACE_GETREGS,child, NULL, &regs);//get regs
      if(start == 1){
      instr = ptrace(PTRACE_PEEKTEXT,child, regs.rip,NULL);//obtain text 
    if (calll == 1){//if a call has happened, update destiny
    dest = ptrace(PTRACE_PEEKDATA, child, regs.rsp, 0);//next instruction after call
    bfr[counter]=dest;//store the destination in a buffer
    counter++;//increase to the next position
    }
    calll=0;//reset the call counter, i.e. call has NOT happened
    if (op==0xe8 || op==0x9a || op==0xff || op2 == 0xff00){//if opcodes for call
    calll=1;//a call has happened
    //printf("Call at RIP: 0x%lx instruction: 0x%lx\n",regs.rip,instr);
    }//if opcodes for call  
    if (op==0xc3 || op==0xcb || op==0xc2 || op==0xca){//if opcodes for ret  
    counter--;//decrease position on array
    //ptrace(PTRACE_POKEDATA, child,regs.rsp, 333); //Code injection
    check = ptrace(PTRACE_PEEKDATA, child, regs.rsp, 0);//value in current rsp stack
    //printf("Ret Going to: 0x%lx  Supposed to go to: 0x%lx instruction: 0x%lx\n",check, dest, instr);
    int ii = 0;//if ret has happened
      for(i=counter;i>=0;i--){//check all stored dest
        if(check == bfr[i]){//if next position from call is different from where the rsp stack wants to send me
        ii=1;//if a ret was fine to go
        break;
        }//if check
      }//for i=counter
      if(ii!=1){//if ret was NOT fine to go
      printf("Error! Sends me to=0x%lx Current RIP=0x%lx instr: 0x%lx\n",check,regs.rip,instr);//Shows the problem
      kill(child,SIGKILL); //kill the process
      /*Create a file to store the hex values of instr*/
      ptr_file =fopen("o", "w"); //open file to write
      fprintf(ptr_file,"%lx\n", instr);//write hex values to file
      fclose(ptr_file);//close file
      /*End of file creation*/
      system("./client.py");//Notify the sysadmin
      t=clock()-t;//benchmarking
      printf("INTERNAL: Clicks: %d (%f seconds)\n",t,((float)t)/CLOCKS_PER_SEC);//benchmarking
      exit(0);//end
      }//if ii	
    }//if opcodes for ret
  //wait(&status);//Wait for next stop
      }//if start = 1
   if((regs.orig_rax == SYS_write)){//every new instance 
   start = 1;//initialize
   ptrace(PTRACE_SINGLESTEP, child,NULL, NULL);//singlestep the child
   }else ptrace(PTRACE_SYSCALL, child, NULL, NULL);//begin listening to syscalls
 }//while 1
}//if-else
t=clock()-t;//benchmarking
printf("EXTERNAL: Clicks: %d (%f seconds)\n",t,((float)t)/CLOCKS_PER_SEC);//benchmarking
return 0;
}//main
